/////////////////////////////////////////////////////////////////////////////////////
//
var	typeLink=0;
var	typeText=1;
function superdd_buildSettingPath(isDefault,type){
	var	fso=getFSO();
	var	filename=(type===typeLink?"drop_link.json":"drop_text.json");
	if (isDefault){
		return fso.BuildPath(getResourceDirPath(),filename);
	}
	return fso.BuildPath(getSettingDirPath(),"customize/"+filename);
}
var g_sddkeys=["","Shift","Ctrl","ShiftCtrl"];
var	g_sdddirs=["Up","Down","Left","Right"];
var g_superdd=[];

function superdd_set(type,setting){
	var	brz=setting.browser;
	if(!brz){
		return ;
	}
	var	typeName=(type===typeLink?"Link":"Text");
	for(valName in brz){
		var	frm=document[valName+typeName];
		if(frm&&frm.v&&frm.v.options){
			selectOptionCmd(frm.v.options,getCmdValue(brz[valName]));
		}
	}
}
function superdd_normalizeCmd(setting){
	var	brz=setting.browser;
	if (brz){
		for (var key=0;key<g_sddkeys.length; ++key){
			for (var dir=0;dir<g_sdddirs.length;++dir){
				var	defName="drop"+g_sddkeys[key];
				var	valName=defName+g_sdddirs[dir];
				var def=setting.browser[defName];
				if(!brz[valName]){
					brz[valName]=def;
				}
			}
		}
	}
}
function superdd_loadSetting(type){
	var	path=superdd_buildSettingPath(false,type);
	if (!getFSO().FileExists(path)){
		path=superdd_buildSettingPath(true,type);
	}
	return parseJsonFile(path);
}
function superdd_refresh(type){
	if (g_superdd[type]){
		return;
	}
	var setting=superdd_loadSetting(type);
	if (setting){
		superdd_normalizeCmd(setting);
		g_superdd[type]=setting;
		superdd_set(type,setting);
	}
}
function superdd_reload(type){
	var setting=superdd_loadSetting(type);
	if (setting&&g_superdd[type]){
		g_superdd[type].btn=setting.btn;
	}
}
function superdd_getCurrentSetting(type){
	var	typeName=(type===typeLink?"Link":"Text");
	var	brz={};
	for (var key=0;key<g_sddkeys.length; ++key){
		for (var dir=0;dir<g_sdddirs.length;++dir){
			var	defName="drop"+g_sddkeys[key];
			brz[defName]=g_superdd[type].browser[defName];

			var	valName=defName+g_sdddirs[dir];
			var	frm=document[valName+typeName];
			if(frm&&frm.v&&frm.v.options){
				var cmd=frm.v.options[frm.v.options.selectedIndex].value;
				brz[valName]=cmdValueToCmdObj(cmd);
			}
		}
	}
	return brz;
}
function superdd_save(type){
	var	brz=superdd_getCurrentSetting(type);
	var	setting=g_superdd[type];
	setting.browser=brz;
	var	path=superdd_buildSettingPath(false,type);
	var	json=JSON.stringify(setting,undefined," ");
	writeUnicodeTextFile(path,json);
}
(function(){superdd_refresh(typeLink);superdd_refresh(typeText);})();